require([
    'jquery',
    'jquery/ui',
    'gridstack',
    'gridstack.jqueryui'
], function ($) {
    $(document).ready(function ($) {
        window.BLOCK_TOTAL = 1;
        $('.gridstackContainer').gridstack({
            animate: true,
            auto: true,
            width: 12,
            alwaysShowResizeHandle: /Android|webOS|iPhone|iPad|iPod|BlackBerry|IEMobile|Opera Mini/i.test(navigator.userAgent),
            resizable: {
                handles: 'e, se, s, sw, w'
            }
        });

        $('.gridstackContainer').on('change removed resizestart gsresizestop dragstart dragstop added', function (event, items) {
            $('.grid-stack-item').each(function (index) {
                $(this).find('.grid-stack-item-sortorder').html(index + 1);
                $(this).find('.grid-stack-item-size').html($(this).width() + " x " + $(this).height());
            });
        });

        $('#addNewBannerBlock').click(function () {
            var nextBlockRef = window.BLOCK_TOTAL = window.BLOCK_TOTAL + 1;
            var grid = $('.gridstackContainer').data('gridstack');
            var el = $.parseHTML("<div class='grid-stack-item'><div class=\"grid-stack-item-content\"><div class=\"grid-stack-item-sortorder\">" + nextBlockRef + "</div>Block " + nextBlockRef + "<div class='grid-stack-item-size'></div><a href=\"Javascript: void(0);\" class=\"grid-stack-item-remove\">Remove Block</a></div></div>");
            var liClass = "admin__page-nav-item ui-state-default ui-corner-top";
            var aClass = "admin__page-nav-link tab-item-link ui-tabs-anchor";

            grid.addWidget(el, 0, 0, 2, 2, true, null, null, null, null, 'block_' + nextBlockRef);
            $('.gridstackContainer').change();
            $('.banner-blocks-list ul.block-list').append(
                "<li class='" + liClass + "'><a class='" + aClass + "' id=\"switch-block\" href='Javascript:void(0);' data-block-id='" + nextBlockRef + "'>Block " + nextBlockRef + "</a></li>"
            );
        });

        $(document).on('click', '#switch-block', function () {
            var currentBlockTab = localStorage.getItem("current_block_edit_id");
            if (!window.IGNORE_FIRST) {
                localStorage.setItem("block_" + currentBlockTab, JSON.stringify($('form.block-form').serializeArray()));
            } else {
                window.IGNORE_FIRST = false;
            }

            var currentBlock = localStorage.getItem("block_" + $(this).data('block-id'));
            if (currentBlock) {
                $.each($.parseJSON(currentBlock), function (key, value) {
                    $('[name=' + value.name + ']', 'form.block-form').val(value.value);

                    if (value.name === 'block_image_url') {
                        $('#image-preview').attr('style', "background-image: url('"+value.value+"');");
                    }
                });
            } else {
                $('form.block-form').get(0).reset();
                $('#block_image_url').val('');
                $('#image-preview').removeAttr('style');
            }

            $('.block-editor .image-size').html(
                $('.grid-stack-item[data-gs-id="block_'+$(this).data('block-id')+'"]').find('.grid-stack-item-size').html()
            );
            $('ul li.ui-tabs-active.ui-state-active').removeClass("ui-tabs-active ui-state-active");
            $(this).parent().addClass("ui-tabs-active ui-state-active");

            localStorage.setItem("current_block_edit_id", $(this).data('block-id'));
        });

        $('form.block-form input, form.block-form select').change(function(){
            var currentBlockTab = localStorage.getItem("current_block_edit_id");
            localStorage.setItem("block_" + currentBlockTab, JSON.stringify($('form.block-form').serializeArray()));
        });

        $(document).on('click', '.grid-stack-item-remove', function () {
            removeGridStackBlock($(this).closest('.grid-stack-item').data('gs-id'));
        });

        function removeGridStackBlock(blockId) {
            _.map($('.grid-stack .grid-stack-item:visible'), function (el) {
                el = $(el);
                if (el.attr('data-gs-id') == blockId) {
                    $('.grid-stack').data('gridstack').removeWidget(el);
                    localStorage.removeItem(blockId);
                    $('#switch-block[data-block-id="' + blockId.split('_')[1] + '"]').parent().remove();

                    $('.block-list li a').first().click();
                }
            });
        }

        $('.gridstackContainer').change();
    });
});